/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.enums.EnumParser;
import de.ship.db.tables.records.TInputParserRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputParser extends TableImpl<TInputParserRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_parser</code>
     */
    public static final TInputParser T_INPUT_PARSER = new TInputParser();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputParserRecord> getRecordType() {
        return TInputParserRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_parser.lastchange</code>.
     */
    public final TableField<TInputParserRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_input_parser.pk</code>. the unique name of
     * this parser like osirix
     */
    public final TableField<TInputParserRecord, String> PK = createField(DSL.name("pk"), SQLDataType.CLOB.nullable(false), this, "the unique name of this parser like osirix");

    /**
     * The column <code>common_dd.t_input_parser.pattern</code>. the validation
     * schema of the parse like an xsd file content
     */
    public final TableField<TInputParserRecord, String> PATTERN = createField(DSL.name("pattern"), SQLDataType.CLOB.nullable(false), this, "the validation schema of the parse like an xsd file content");

    /**
     * The column <code>common_dd.t_input_parser.type</code>. the type of this
     * parser
     */
    public final TableField<TInputParserRecord, EnumParser> TYPE = createField(DSL.name("type"), SQLDataType.VARCHAR.nullable(false).asEnumDataType(EnumParser.class), this, "the type of this parser");

    private TInputParser(Name alias, Table<TInputParserRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputParser(Name alias, Table<TInputParserRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_parser</code> table reference
     */
    public TInputParser(String alias) {
        this(DSL.name(alias), T_INPUT_PARSER);
    }

    /**
     * Create an aliased <code>common_dd.t_input_parser</code> table reference
     */
    public TInputParser(Name alias) {
        this(alias, T_INPUT_PARSER);
    }

    /**
     * Create a <code>common_dd.t_input_parser</code> table reference
     */
    public TInputParser() {
        this(DSL.name("t_input_parser"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<UniqueKey<TInputParserRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_INPUT_PARSER_PK, Keys.UK_INPUT_PARSER_PATTERN);
    }

    @Override
    public TInputParser as(String alias) {
        return new TInputParser(DSL.name(alias), this);
    }

    @Override
    public TInputParser as(Name alias) {
        return new TInputParser(alias, this);
    }

    @Override
    public TInputParser as(Table<?> alias) {
        return new TInputParser(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputParser rename(String name) {
        return new TInputParser(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputParser rename(Name name) {
        return new TInputParser(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputParser rename(Table<?> name) {
        return new TInputParser(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParser where(Condition condition) {
        return new TInputParser(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParser where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParser where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParser where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputParser where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputParser where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputParser where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputParser where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParser whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputParser whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
